use 5.6.0;
use strict;
#------------------------------------------------------------------------------
# ᡼⥸塼
#						(C)2006-11 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Base::Mail;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
my $sendmail_cmd = '/usr/sbin/sendmail';
#
# use Symbol ();
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	$self->{ROBJ} = shift;
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ᡼
#------------------------------------------------------------------------------
sub send_mail {
	my ($self, $h) = @_;
	my $ROBJ = $self->{ROBJ};

	# ǧ
	my $from = $h->{from};
	my $to   = $h->{to};
	my $cc   = $h->{cc};
	my $bcc  = $h->{bcc};
	$self->check_mail_address( $from, $to, $cc, $bcc );
	if ($to   eq '') { $ROBJ->message('"To" is invalid');   return 1; }
	if ($from eq '') { $ROBJ->message('"From" is invalid'); return 2; }
	my $from_orig = $from;

	# ƥȷ
	my $from_name = $h->{from_name};
	my $to_name   = $h->{to_name};
	my $cc_name   = $h->{cc_name};
	my $subject   = $h->{subject};
	my $text      = $h->{text};
	foreach($from_name, $to_name, $cc_name) {
		$_ =~ s/[\x00-\x1f<>\"]//g;
	}
	$subject =~ s/[\x00-\x08\x0a-\x1f]//g;		# TABʳ
	$text    =~ s/[\x00-\x08\x0b\x0c\x0e-\x1f]//g;	# TAB, LF, CRʳ

	# JISѴ
	my $jcode = $ROBJ->loadpm('Jcode');
	foreach($from_name, $to_name, $cc_name, $subject, $text) {
		$_ = $jcode->from_to($_, $ROBJ->{System_coding}, 'JIS');
	}
	# MIME
	$self->mime_encode($from_name, $to_name, $cc_name, $subject);

	# from, to βù
	if ($from_name) { $from = "$from_name <$from>"; }
	if ($to_name)   { $to   = "$to_name <$to>"; }
	if ($cc_name)   { $cc   = "$cc_name <$cc>"; }

	#-------------------------------------------------------
	# ᡼
	#-------------------------------------------------------
	if (!-x $sendmail_cmd) {
		$ROBJ->message('sendmail command not found');
		return 10;
	}
	my $fh;
	if (! open($fh, "| $sendmail_cmd -t -i -f '$from_orig'")) {
		$ROBJ->message('Internal Error'); return 11;
	}
	if ($cc)  { print $fh "Cc: $cc\n"; }
	if ($bcc) { print $fh "Bcc: $bcc\n"; }
print $fh <<END;
From: $from
To: $to
Subject: $subject
Return-Path: $from_orig
MIME-Version: 1.0
Content-Type: text/plain; charset="ISO-2022-JP"
Content-Transfer-Encoding: 7bit

$text
END
	close($fh);
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
sub check_mail_address {
	my $self = shift;
	foreach(@_) {
		if ($_ !~ /^[-_\.a-zA-Z0-9]+\@[-_\.a-zA-Z0-9]+$/) { $_=undef; }
	}
	return $_[0];
}
###############################################################################
# MIME base64󥳡/ǥ
###############################################################################
my $base64table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
my @base64ary = (
 0, 0, 0, 0,  0, 0, 0, 0,   0, 0, 0, 0,  0, 0, 0, 0,	# 0x000x1f
 0, 0, 0, 0,  0, 0, 0, 0,   0, 0, 0, 0,  0, 0, 0, 0,	# 0x100x1f
 0, 0, 0, 0,  0, 0, 0, 0,   0, 0, 0,62,  0, 0, 0,63,	# 0x200x2f
52,53,54,55, 56,57,58,59,  60,61, 0, 0,  0, 0, 0, 0,	# 0x300x3f
 0, 0, 1, 2,  3, 4, 5, 6,   7, 8, 9,10, 11,12,13,14,	# 0x400x4f
15,16,17,18, 19,20,21,22,  23,24,25, 0,  0, 0, 0, 0,	# 0x500x5f
 0,26,27,28, 29,30,31,32,  33,34,35,36, 37,38,39,40,	# 0x600x6f
41,42,43,44, 45,46,47,48,  49,50,51, 0,  0, 0, 0, 0	# 0x700x7f
);

#------------------------------------------------------------------------------
# 󥳡
#------------------------------------------------------------------------------
sub mime_encode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/(\e\$[\@B].*?\e\([BJ])/ '=?ISO-2022-JP?B?' . $self->base64encode($1) . '?=' /eg;
	}
	return $_[0];
}
sub base64encode {
	my $self = shift;
	my $str  = shift;
	my $ret;

	# 2 : 0000_0000 1111_1100
	# 4 : 0000_0011 1111_0000
	# 6 : 0000_1111 1100_0000
	my ($i, $j, $x, $y);
	for($i=$x=0, $j=2; $i<length($str); $i++) {
		$x    = ($x<<8) + ord(substr($str,$i,1));
		$ret .= substr($base64table, ($x>>$j) & 0x3f, 1);

		if ($j != 6) { $j+=2; next; }
		# j==6
		$ret .= substr($base64table, $x & 0x3f, 1);
		$j    = 2;
	}
	if ($j != 2)    { $ret .= substr($base64table, ($x<<(8-$j)) & 0x3f, 1); }
	if ($j == 4)    { $ret .= '=='; }
	elsif ($j == 6) { $ret .= '=';  }

	return $ret;
}
#------------------------------------------------------------------------------
# ǥ
#------------------------------------------------------------------------------
sub mime_decode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/=\?ISO-2022-JP\?B\?([A-Za-z0-9\+\/=]*)\?=/ $self->base64decode($1) /eg;
	}
	return $_[0];
}
sub base64decode {
	my $self = shift;
	my $str  = shift;

	my $ret;
	my $buf;
	my $f;
	if (substr($str, -1) eq  '=') { $f=1; }
	if (substr($str, -2) eq '==') { $f=2; }
	for(my $i=0; $i<length($str); $i+=4) {
		$buf  = ($buf<<6) + $base64ary[ ord(substr($str,$i  ,1)) ];
		$buf  = ($buf<<6) + $base64ary[ ord(substr($str,$i+1,1)) ];
		$buf  = ($buf<<6) + $base64ary[ ord(substr($str,$i+2,1)) ];
		$buf  = ($buf<<6) + $base64ary[ ord(substr($str,$i+3,1)) ];
		$ret .= chr(($buf & 0xff0000)>>16) . chr(($buf & 0xff00)>>8) . chr($buf & 0xff);

	}
	if ($f>0) { chop($ret); }
	if ($f>1) { chop($ret); }
	return $ret;
}

1;
